#[doc = "Register `ACTL4` reader"]
pub struct R(crate::R<ACTL4_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<ACTL4_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<ACTL4_SPEC>> for R {
    fn from(reader: crate::R<ACTL4_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `ACTL4` writer"]
pub struct W(crate::W<ACTL4_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<ACTL4_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<ACTL4_SPEC>> for W {
    fn from(writer: crate::W<ACTL4_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "FIFO clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO0_CLR_0_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    CLEAR = 1,
}
impl From<FIFO0_CLR_0_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO0_CLR_0_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO0_CLR_0` reader - FIFO clear"]
pub struct FIFO0_CLR_0_R(crate::FieldReader<bool, FIFO0_CLR_0_A>);
impl FIFO0_CLR_0_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO0_CLR_0_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO0_CLR_0_A {
        match self.bits {
            false => FIFO0_CLR_0_A::NORMAL,
            true => FIFO0_CLR_0_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO0_CLR_0_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        **self == FIFO0_CLR_0_A::CLEAR
    }
}
impl core::ops::Deref for FIFO0_CLR_0_R {
    type Target = crate::FieldReader<bool, FIFO0_CLR_0_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO0_CLR_0` writer - FIFO clear"]
pub struct FIFO0_CLR_0_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO0_CLR_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO0_CLR_0_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO0_CLR_0_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FIFO0_CLR_0_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
        self.w
    }
}
#[doc = "FIFO clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO1_CLR_0_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    CLEAR = 1,
}
impl From<FIFO1_CLR_0_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO1_CLR_0_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO1_CLR_0` reader - FIFO clear"]
pub struct FIFO1_CLR_0_R(crate::FieldReader<bool, FIFO1_CLR_0_A>);
impl FIFO1_CLR_0_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO1_CLR_0_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO1_CLR_0_A {
        match self.bits {
            false => FIFO1_CLR_0_A::NORMAL,
            true => FIFO1_CLR_0_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO1_CLR_0_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        **self == FIFO1_CLR_0_A::CLEAR
    }
}
impl core::ops::Deref for FIFO1_CLR_0_R {
    type Target = crate::FieldReader<bool, FIFO1_CLR_0_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO1_CLR_0` writer - FIFO clear"]
pub struct FIFO1_CLR_0_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO1_CLR_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO1_CLR_0_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO1_CLR_0_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FIFO1_CLR_0_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u32 & 0x01) << 1);
        self.w
    }
}
#[doc = "FIFO fill status level control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO0_LVL_0_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    MID = 1,
}
impl From<FIFO0_LVL_0_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO0_LVL_0_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO0_LVL_0` reader - FIFO fill status level control"]
pub struct FIFO0_LVL_0_R(crate::FieldReader<bool, FIFO0_LVL_0_A>);
impl FIFO0_LVL_0_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO0_LVL_0_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO0_LVL_0_A {
        match self.bits {
            false => FIFO0_LVL_0_A::NORMAL,
            true => FIFO0_LVL_0_A::MID,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO0_LVL_0_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `MID`"]
    #[inline(always)]
    pub fn is_mid(&self) -> bool {
        **self == FIFO0_LVL_0_A::MID
    }
}
impl core::ops::Deref for FIFO0_LVL_0_R {
    type Target = crate::FieldReader<bool, FIFO0_LVL_0_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO0_LVL_0` writer - FIFO fill status level control"]
pub struct FIFO0_LVL_0_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO0_LVL_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO0_LVL_0_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO0_LVL_0_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn mid(self) -> &'a mut W {
        self.variant(FIFO0_LVL_0_A::MID)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | ((value as u32 & 0x01) << 2);
        self.w
    }
}
#[doc = "FIFO fill status level control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO1_LVL_0_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    MID = 1,
}
impl From<FIFO1_LVL_0_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO1_LVL_0_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO1_LVL_0` reader - FIFO fill status level control"]
pub struct FIFO1_LVL_0_R(crate::FieldReader<bool, FIFO1_LVL_0_A>);
impl FIFO1_LVL_0_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO1_LVL_0_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO1_LVL_0_A {
        match self.bits {
            false => FIFO1_LVL_0_A::NORMAL,
            true => FIFO1_LVL_0_A::MID,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO1_LVL_0_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `MID`"]
    #[inline(always)]
    pub fn is_mid(&self) -> bool {
        **self == FIFO1_LVL_0_A::MID
    }
}
impl core::ops::Deref for FIFO1_LVL_0_R {
    type Target = crate::FieldReader<bool, FIFO1_LVL_0_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO1_LVL_0` writer - FIFO fill status level control"]
pub struct FIFO1_LVL_0_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO1_LVL_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO1_LVL_0_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO1_LVL_0_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn mid(self) -> &'a mut W {
        self.variant(FIFO1_LVL_0_A::MID)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 3)) | ((value as u32 & 0x01) << 3);
        self.w
    }
}
#[doc = "enable interrupt\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INT_EN_0_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<INT_EN_0_A> for bool {
    #[inline(always)]
    fn from(variant: INT_EN_0_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `INT_EN_0` reader - enable interrupt"]
pub struct INT_EN_0_R(crate::FieldReader<bool, INT_EN_0_A>);
impl INT_EN_0_R {
    pub(crate) fn new(bits: bool) -> Self {
        INT_EN_0_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INT_EN_0_A {
        match self.bits {
            false => INT_EN_0_A::DISABLE,
            true => INT_EN_0_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == INT_EN_0_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == INT_EN_0_A::ENABLE
    }
}
impl core::ops::Deref for INT_EN_0_R {
    type Target = crate::FieldReader<bool, INT_EN_0_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `INT_EN_0` writer - enable interrupt"]
pub struct INT_EN_0_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_EN_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INT_EN_0_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(INT_EN_0_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(INT_EN_0_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 4)) | ((value as u32 & 0x01) << 4);
        self.w
    }
}
#[doc = "Control Register Counter Enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CNT_START_0_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<CNT_START_0_A> for bool {
    #[inline(always)]
    fn from(variant: CNT_START_0_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `CNT_START_0` reader - Control Register Counter Enable"]
pub struct CNT_START_0_R(crate::FieldReader<bool, CNT_START_0_A>);
impl CNT_START_0_R {
    pub(crate) fn new(bits: bool) -> Self {
        CNT_START_0_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CNT_START_0_A {
        match self.bits {
            false => CNT_START_0_A::DISABLE,
            true => CNT_START_0_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == CNT_START_0_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == CNT_START_0_A::ENABLE
    }
}
impl core::ops::Deref for CNT_START_0_R {
    type Target = crate::FieldReader<bool, CNT_START_0_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CNT_START_0` writer - Control Register Counter Enable"]
pub struct CNT_START_0_W<'a> {
    w: &'a mut W,
}
impl<'a> CNT_START_0_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CNT_START_0_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(CNT_START_0_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(CNT_START_0_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 5)) | ((value as u32 & 0x01) << 5);
        self.w
    }
}
#[doc = "FIFO clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO0_CLR_1_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    CLEAR = 1,
}
impl From<FIFO0_CLR_1_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO0_CLR_1_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO0_CLR_1` reader - FIFO clear"]
pub struct FIFO0_CLR_1_R(crate::FieldReader<bool, FIFO0_CLR_1_A>);
impl FIFO0_CLR_1_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO0_CLR_1_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO0_CLR_1_A {
        match self.bits {
            false => FIFO0_CLR_1_A::NORMAL,
            true => FIFO0_CLR_1_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO0_CLR_1_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        **self == FIFO0_CLR_1_A::CLEAR
    }
}
impl core::ops::Deref for FIFO0_CLR_1_R {
    type Target = crate::FieldReader<bool, FIFO0_CLR_1_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO0_CLR_1` writer - FIFO clear"]
pub struct FIFO0_CLR_1_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO0_CLR_1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO0_CLR_1_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO0_CLR_1_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FIFO0_CLR_1_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 8)) | ((value as u32 & 0x01) << 8);
        self.w
    }
}
#[doc = "FIFO clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO1_CLR_1_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    CLEAR = 1,
}
impl From<FIFO1_CLR_1_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO1_CLR_1_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO1_CLR_1` reader - FIFO clear"]
pub struct FIFO1_CLR_1_R(crate::FieldReader<bool, FIFO1_CLR_1_A>);
impl FIFO1_CLR_1_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO1_CLR_1_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO1_CLR_1_A {
        match self.bits {
            false => FIFO1_CLR_1_A::NORMAL,
            true => FIFO1_CLR_1_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO1_CLR_1_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        **self == FIFO1_CLR_1_A::CLEAR
    }
}
impl core::ops::Deref for FIFO1_CLR_1_R {
    type Target = crate::FieldReader<bool, FIFO1_CLR_1_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO1_CLR_1` writer - FIFO clear"]
pub struct FIFO1_CLR_1_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO1_CLR_1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO1_CLR_1_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO1_CLR_1_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FIFO1_CLR_1_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 9)) | ((value as u32 & 0x01) << 9);
        self.w
    }
}
#[doc = "FIFO fill status level control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO0_LVL_1_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    MID = 1,
}
impl From<FIFO0_LVL_1_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO0_LVL_1_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO0_LVL_1` reader - FIFO fill status level control"]
pub struct FIFO0_LVL_1_R(crate::FieldReader<bool, FIFO0_LVL_1_A>);
impl FIFO0_LVL_1_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO0_LVL_1_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO0_LVL_1_A {
        match self.bits {
            false => FIFO0_LVL_1_A::NORMAL,
            true => FIFO0_LVL_1_A::MID,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO0_LVL_1_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `MID`"]
    #[inline(always)]
    pub fn is_mid(&self) -> bool {
        **self == FIFO0_LVL_1_A::MID
    }
}
impl core::ops::Deref for FIFO0_LVL_1_R {
    type Target = crate::FieldReader<bool, FIFO0_LVL_1_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO0_LVL_1` writer - FIFO fill status level control"]
pub struct FIFO0_LVL_1_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO0_LVL_1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO0_LVL_1_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO0_LVL_1_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn mid(self) -> &'a mut W {
        self.variant(FIFO0_LVL_1_A::MID)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 10)) | ((value as u32 & 0x01) << 10);
        self.w
    }
}
#[doc = "FIFO fill status level control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO1_LVL_1_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    MID = 1,
}
impl From<FIFO1_LVL_1_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO1_LVL_1_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO1_LVL_1` reader - FIFO fill status level control"]
pub struct FIFO1_LVL_1_R(crate::FieldReader<bool, FIFO1_LVL_1_A>);
impl FIFO1_LVL_1_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO1_LVL_1_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO1_LVL_1_A {
        match self.bits {
            false => FIFO1_LVL_1_A::NORMAL,
            true => FIFO1_LVL_1_A::MID,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO1_LVL_1_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `MID`"]
    #[inline(always)]
    pub fn is_mid(&self) -> bool {
        **self == FIFO1_LVL_1_A::MID
    }
}
impl core::ops::Deref for FIFO1_LVL_1_R {
    type Target = crate::FieldReader<bool, FIFO1_LVL_1_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO1_LVL_1` writer - FIFO fill status level control"]
pub struct FIFO1_LVL_1_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO1_LVL_1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO1_LVL_1_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO1_LVL_1_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn mid(self) -> &'a mut W {
        self.variant(FIFO1_LVL_1_A::MID)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 11)) | ((value as u32 & 0x01) << 11);
        self.w
    }
}
#[doc = "enable interrupt\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INT_EN_1_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<INT_EN_1_A> for bool {
    #[inline(always)]
    fn from(variant: INT_EN_1_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `INT_EN_1` reader - enable interrupt"]
pub struct INT_EN_1_R(crate::FieldReader<bool, INT_EN_1_A>);
impl INT_EN_1_R {
    pub(crate) fn new(bits: bool) -> Self {
        INT_EN_1_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INT_EN_1_A {
        match self.bits {
            false => INT_EN_1_A::DISABLE,
            true => INT_EN_1_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == INT_EN_1_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == INT_EN_1_A::ENABLE
    }
}
impl core::ops::Deref for INT_EN_1_R {
    type Target = crate::FieldReader<bool, INT_EN_1_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `INT_EN_1` writer - enable interrupt"]
pub struct INT_EN_1_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_EN_1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INT_EN_1_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(INT_EN_1_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(INT_EN_1_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 12)) | ((value as u32 & 0x01) << 12);
        self.w
    }
}
#[doc = "Control Register Counter Enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CNT_START_1_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<CNT_START_1_A> for bool {
    #[inline(always)]
    fn from(variant: CNT_START_1_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `CNT_START_1` reader - Control Register Counter Enable"]
pub struct CNT_START_1_R(crate::FieldReader<bool, CNT_START_1_A>);
impl CNT_START_1_R {
    pub(crate) fn new(bits: bool) -> Self {
        CNT_START_1_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CNT_START_1_A {
        match self.bits {
            false => CNT_START_1_A::DISABLE,
            true => CNT_START_1_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == CNT_START_1_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == CNT_START_1_A::ENABLE
    }
}
impl core::ops::Deref for CNT_START_1_R {
    type Target = crate::FieldReader<bool, CNT_START_1_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CNT_START_1` writer - Control Register Counter Enable"]
pub struct CNT_START_1_W<'a> {
    w: &'a mut W,
}
impl<'a> CNT_START_1_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CNT_START_1_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(CNT_START_1_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(CNT_START_1_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 13)) | ((value as u32 & 0x01) << 13);
        self.w
    }
}
#[doc = "FIFO clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO0_CLR_2_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    CLEAR = 1,
}
impl From<FIFO0_CLR_2_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO0_CLR_2_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO0_CLR_2` reader - FIFO clear"]
pub struct FIFO0_CLR_2_R(crate::FieldReader<bool, FIFO0_CLR_2_A>);
impl FIFO0_CLR_2_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO0_CLR_2_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO0_CLR_2_A {
        match self.bits {
            false => FIFO0_CLR_2_A::NORMAL,
            true => FIFO0_CLR_2_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO0_CLR_2_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        **self == FIFO0_CLR_2_A::CLEAR
    }
}
impl core::ops::Deref for FIFO0_CLR_2_R {
    type Target = crate::FieldReader<bool, FIFO0_CLR_2_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO0_CLR_2` writer - FIFO clear"]
pub struct FIFO0_CLR_2_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO0_CLR_2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO0_CLR_2_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO0_CLR_2_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FIFO0_CLR_2_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 16)) | ((value as u32 & 0x01) << 16);
        self.w
    }
}
#[doc = "FIFO clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO1_CLR_2_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    CLEAR = 1,
}
impl From<FIFO1_CLR_2_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO1_CLR_2_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO1_CLR_2` reader - FIFO clear"]
pub struct FIFO1_CLR_2_R(crate::FieldReader<bool, FIFO1_CLR_2_A>);
impl FIFO1_CLR_2_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO1_CLR_2_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO1_CLR_2_A {
        match self.bits {
            false => FIFO1_CLR_2_A::NORMAL,
            true => FIFO1_CLR_2_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO1_CLR_2_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        **self == FIFO1_CLR_2_A::CLEAR
    }
}
impl core::ops::Deref for FIFO1_CLR_2_R {
    type Target = crate::FieldReader<bool, FIFO1_CLR_2_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO1_CLR_2` writer - FIFO clear"]
pub struct FIFO1_CLR_2_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO1_CLR_2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO1_CLR_2_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO1_CLR_2_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FIFO1_CLR_2_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 17)) | ((value as u32 & 0x01) << 17);
        self.w
    }
}
#[doc = "FIFO fill status level control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO0_LVL_2_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    MID = 1,
}
impl From<FIFO0_LVL_2_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO0_LVL_2_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO0_LVL_2` reader - FIFO fill status level control"]
pub struct FIFO0_LVL_2_R(crate::FieldReader<bool, FIFO0_LVL_2_A>);
impl FIFO0_LVL_2_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO0_LVL_2_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO0_LVL_2_A {
        match self.bits {
            false => FIFO0_LVL_2_A::NORMAL,
            true => FIFO0_LVL_2_A::MID,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO0_LVL_2_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `MID`"]
    #[inline(always)]
    pub fn is_mid(&self) -> bool {
        **self == FIFO0_LVL_2_A::MID
    }
}
impl core::ops::Deref for FIFO0_LVL_2_R {
    type Target = crate::FieldReader<bool, FIFO0_LVL_2_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO0_LVL_2` writer - FIFO fill status level control"]
pub struct FIFO0_LVL_2_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO0_LVL_2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO0_LVL_2_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO0_LVL_2_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn mid(self) -> &'a mut W {
        self.variant(FIFO0_LVL_2_A::MID)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 18)) | ((value as u32 & 0x01) << 18);
        self.w
    }
}
#[doc = "FIFO fill status level control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO1_LVL_2_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    MID = 1,
}
impl From<FIFO1_LVL_2_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO1_LVL_2_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO1_LVL_2` reader - FIFO fill status level control"]
pub struct FIFO1_LVL_2_R(crate::FieldReader<bool, FIFO1_LVL_2_A>);
impl FIFO1_LVL_2_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO1_LVL_2_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO1_LVL_2_A {
        match self.bits {
            false => FIFO1_LVL_2_A::NORMAL,
            true => FIFO1_LVL_2_A::MID,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO1_LVL_2_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `MID`"]
    #[inline(always)]
    pub fn is_mid(&self) -> bool {
        **self == FIFO1_LVL_2_A::MID
    }
}
impl core::ops::Deref for FIFO1_LVL_2_R {
    type Target = crate::FieldReader<bool, FIFO1_LVL_2_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO1_LVL_2` writer - FIFO fill status level control"]
pub struct FIFO1_LVL_2_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO1_LVL_2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO1_LVL_2_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO1_LVL_2_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn mid(self) -> &'a mut W {
        self.variant(FIFO1_LVL_2_A::MID)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 19)) | ((value as u32 & 0x01) << 19);
        self.w
    }
}
#[doc = "enable interrupt\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INT_EN_2_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<INT_EN_2_A> for bool {
    #[inline(always)]
    fn from(variant: INT_EN_2_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `INT_EN_2` reader - enable interrupt"]
pub struct INT_EN_2_R(crate::FieldReader<bool, INT_EN_2_A>);
impl INT_EN_2_R {
    pub(crate) fn new(bits: bool) -> Self {
        INT_EN_2_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INT_EN_2_A {
        match self.bits {
            false => INT_EN_2_A::DISABLE,
            true => INT_EN_2_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == INT_EN_2_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == INT_EN_2_A::ENABLE
    }
}
impl core::ops::Deref for INT_EN_2_R {
    type Target = crate::FieldReader<bool, INT_EN_2_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `INT_EN_2` writer - enable interrupt"]
pub struct INT_EN_2_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_EN_2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INT_EN_2_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(INT_EN_2_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(INT_EN_2_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 20)) | ((value as u32 & 0x01) << 20);
        self.w
    }
}
#[doc = "Control Register Counter Enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CNT_START_2_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<CNT_START_2_A> for bool {
    #[inline(always)]
    fn from(variant: CNT_START_2_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `CNT_START_2` reader - Control Register Counter Enable"]
pub struct CNT_START_2_R(crate::FieldReader<bool, CNT_START_2_A>);
impl CNT_START_2_R {
    pub(crate) fn new(bits: bool) -> Self {
        CNT_START_2_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CNT_START_2_A {
        match self.bits {
            false => CNT_START_2_A::DISABLE,
            true => CNT_START_2_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == CNT_START_2_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == CNT_START_2_A::ENABLE
    }
}
impl core::ops::Deref for CNT_START_2_R {
    type Target = crate::FieldReader<bool, CNT_START_2_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CNT_START_2` writer - Control Register Counter Enable"]
pub struct CNT_START_2_W<'a> {
    w: &'a mut W,
}
impl<'a> CNT_START_2_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CNT_START_2_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(CNT_START_2_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(CNT_START_2_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 21)) | ((value as u32 & 0x01) << 21);
        self.w
    }
}
#[doc = "FIFO clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO0_CLR_3_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    CLEAR = 1,
}
impl From<FIFO0_CLR_3_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO0_CLR_3_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO0_CLR_3` reader - FIFO clear"]
pub struct FIFO0_CLR_3_R(crate::FieldReader<bool, FIFO0_CLR_3_A>);
impl FIFO0_CLR_3_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO0_CLR_3_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO0_CLR_3_A {
        match self.bits {
            false => FIFO0_CLR_3_A::NORMAL,
            true => FIFO0_CLR_3_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO0_CLR_3_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        **self == FIFO0_CLR_3_A::CLEAR
    }
}
impl core::ops::Deref for FIFO0_CLR_3_R {
    type Target = crate::FieldReader<bool, FIFO0_CLR_3_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO0_CLR_3` writer - FIFO clear"]
pub struct FIFO0_CLR_3_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO0_CLR_3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO0_CLR_3_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO0_CLR_3_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FIFO0_CLR_3_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 24)) | ((value as u32 & 0x01) << 24);
        self.w
    }
}
#[doc = "FIFO clear\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO1_CLR_3_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    CLEAR = 1,
}
impl From<FIFO1_CLR_3_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO1_CLR_3_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO1_CLR_3` reader - FIFO clear"]
pub struct FIFO1_CLR_3_R(crate::FieldReader<bool, FIFO1_CLR_3_A>);
impl FIFO1_CLR_3_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO1_CLR_3_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO1_CLR_3_A {
        match self.bits {
            false => FIFO1_CLR_3_A::NORMAL,
            true => FIFO1_CLR_3_A::CLEAR,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO1_CLR_3_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `CLEAR`"]
    #[inline(always)]
    pub fn is_clear(&self) -> bool {
        **self == FIFO1_CLR_3_A::CLEAR
    }
}
impl core::ops::Deref for FIFO1_CLR_3_R {
    type Target = crate::FieldReader<bool, FIFO1_CLR_3_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO1_CLR_3` writer - FIFO clear"]
pub struct FIFO1_CLR_3_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO1_CLR_3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO1_CLR_3_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO1_CLR_3_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn clear(self) -> &'a mut W {
        self.variant(FIFO1_CLR_3_A::CLEAR)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 25)) | ((value as u32 & 0x01) << 25);
        self.w
    }
}
#[doc = "FIFO fill status level control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO0_LVL_3_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    MID = 1,
}
impl From<FIFO0_LVL_3_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO0_LVL_3_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO0_LVL_3` reader - FIFO fill status level control"]
pub struct FIFO0_LVL_3_R(crate::FieldReader<bool, FIFO0_LVL_3_A>);
impl FIFO0_LVL_3_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO0_LVL_3_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO0_LVL_3_A {
        match self.bits {
            false => FIFO0_LVL_3_A::NORMAL,
            true => FIFO0_LVL_3_A::MID,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO0_LVL_3_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `MID`"]
    #[inline(always)]
    pub fn is_mid(&self) -> bool {
        **self == FIFO0_LVL_3_A::MID
    }
}
impl core::ops::Deref for FIFO0_LVL_3_R {
    type Target = crate::FieldReader<bool, FIFO0_LVL_3_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO0_LVL_3` writer - FIFO fill status level control"]
pub struct FIFO0_LVL_3_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO0_LVL_3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO0_LVL_3_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO0_LVL_3_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn mid(self) -> &'a mut W {
        self.variant(FIFO0_LVL_3_A::MID)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 26)) | ((value as u32 & 0x01) << 26);
        self.w
    }
}
#[doc = "FIFO fill status level control\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum FIFO1_LVL_3_A {
    #[doc = "0: No description available"]
    NORMAL = 0,
    #[doc = "1: No description available"]
    MID = 1,
}
impl From<FIFO1_LVL_3_A> for bool {
    #[inline(always)]
    fn from(variant: FIFO1_LVL_3_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `FIFO1_LVL_3` reader - FIFO fill status level control"]
pub struct FIFO1_LVL_3_R(crate::FieldReader<bool, FIFO1_LVL_3_A>);
impl FIFO1_LVL_3_R {
    pub(crate) fn new(bits: bool) -> Self {
        FIFO1_LVL_3_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> FIFO1_LVL_3_A {
        match self.bits {
            false => FIFO1_LVL_3_A::NORMAL,
            true => FIFO1_LVL_3_A::MID,
        }
    }
    #[doc = "Checks if the value of the field is `NORMAL`"]
    #[inline(always)]
    pub fn is_normal(&self) -> bool {
        **self == FIFO1_LVL_3_A::NORMAL
    }
    #[doc = "Checks if the value of the field is `MID`"]
    #[inline(always)]
    pub fn is_mid(&self) -> bool {
        **self == FIFO1_LVL_3_A::MID
    }
}
impl core::ops::Deref for FIFO1_LVL_3_R {
    type Target = crate::FieldReader<bool, FIFO1_LVL_3_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `FIFO1_LVL_3` writer - FIFO fill status level control"]
pub struct FIFO1_LVL_3_W<'a> {
    w: &'a mut W,
}
impl<'a> FIFO1_LVL_3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: FIFO1_LVL_3_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn normal(self) -> &'a mut W {
        self.variant(FIFO1_LVL_3_A::NORMAL)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn mid(self) -> &'a mut W {
        self.variant(FIFO1_LVL_3_A::MID)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 27)) | ((value as u32 & 0x01) << 27);
        self.w
    }
}
#[doc = "enable interrupt\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum INT_EN_3_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<INT_EN_3_A> for bool {
    #[inline(always)]
    fn from(variant: INT_EN_3_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `INT_EN_3` reader - enable interrupt"]
pub struct INT_EN_3_R(crate::FieldReader<bool, INT_EN_3_A>);
impl INT_EN_3_R {
    pub(crate) fn new(bits: bool) -> Self {
        INT_EN_3_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> INT_EN_3_A {
        match self.bits {
            false => INT_EN_3_A::DISABLE,
            true => INT_EN_3_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == INT_EN_3_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == INT_EN_3_A::ENABLE
    }
}
impl core::ops::Deref for INT_EN_3_R {
    type Target = crate::FieldReader<bool, INT_EN_3_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `INT_EN_3` writer - enable interrupt"]
pub struct INT_EN_3_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_EN_3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: INT_EN_3_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(INT_EN_3_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(INT_EN_3_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 28)) | ((value as u32 & 0x01) << 28);
        self.w
    }
}
#[doc = "Control Register Counter Enable\n\nValue on reset: 0"]
#[derive(Clone, Copy, Debug, PartialEq)]
pub enum CNT_START_3_A {
    #[doc = "0: No description available"]
    DISABLE = 0,
    #[doc = "1: No description available"]
    ENABLE = 1,
}
impl From<CNT_START_3_A> for bool {
    #[inline(always)]
    fn from(variant: CNT_START_3_A) -> Self {
        variant as u8 != 0
    }
}
#[doc = "Field `CNT_START_3` reader - Control Register Counter Enable"]
pub struct CNT_START_3_R(crate::FieldReader<bool, CNT_START_3_A>);
impl CNT_START_3_R {
    pub(crate) fn new(bits: bool) -> Self {
        CNT_START_3_R(crate::FieldReader::new(bits))
    }
    #[doc = r"Get enumerated values variant"]
    #[inline(always)]
    pub fn variant(&self) -> CNT_START_3_A {
        match self.bits {
            false => CNT_START_3_A::DISABLE,
            true => CNT_START_3_A::ENABLE,
        }
    }
    #[doc = "Checks if the value of the field is `DISABLE`"]
    #[inline(always)]
    pub fn is_disable(&self) -> bool {
        **self == CNT_START_3_A::DISABLE
    }
    #[doc = "Checks if the value of the field is `ENABLE`"]
    #[inline(always)]
    pub fn is_enable(&self) -> bool {
        **self == CNT_START_3_A::ENABLE
    }
}
impl core::ops::Deref for CNT_START_3_R {
    type Target = crate::FieldReader<bool, CNT_START_3_A>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `CNT_START_3` writer - Control Register Counter Enable"]
pub struct CNT_START_3_W<'a> {
    w: &'a mut W,
}
impl<'a> CNT_START_3_W<'a> {
    #[doc = r"Writes `variant` to the field"]
    #[inline(always)]
    pub fn variant(self, variant: CNT_START_3_A) -> &'a mut W {
        self.bit(variant.into())
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn disable(self) -> &'a mut W {
        self.variant(CNT_START_3_A::DISABLE)
    }
    #[doc = "No description available"]
    #[inline(always)]
    pub fn enable(self) -> &'a mut W {
        self.variant(CNT_START_3_A::ENABLE)
    }
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 29)) | ((value as u32 & 0x01) << 29);
        self.w
    }
}
impl R {
    #[doc = "Bit 0 - FIFO clear"]
    #[inline(always)]
    pub fn fifo0_clr_0(&self) -> FIFO0_CLR_0_R {
        FIFO0_CLR_0_R::new((self.bits & 0x01) != 0)
    }
    #[doc = "Bit 1 - FIFO clear"]
    #[inline(always)]
    pub fn fifo1_clr_0(&self) -> FIFO1_CLR_0_R {
        FIFO1_CLR_0_R::new(((self.bits >> 1) & 0x01) != 0)
    }
    #[doc = "Bit 2 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo0_lvl_0(&self) -> FIFO0_LVL_0_R {
        FIFO0_LVL_0_R::new(((self.bits >> 2) & 0x01) != 0)
    }
    #[doc = "Bit 3 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo1_lvl_0(&self) -> FIFO1_LVL_0_R {
        FIFO1_LVL_0_R::new(((self.bits >> 3) & 0x01) != 0)
    }
    #[doc = "Bit 4 - enable interrupt"]
    #[inline(always)]
    pub fn int_en_0(&self) -> INT_EN_0_R {
        INT_EN_0_R::new(((self.bits >> 4) & 0x01) != 0)
    }
    #[doc = "Bit 5 - Control Register Counter Enable"]
    #[inline(always)]
    pub fn cnt_start_0(&self) -> CNT_START_0_R {
        CNT_START_0_R::new(((self.bits >> 5) & 0x01) != 0)
    }
    #[doc = "Bit 8 - FIFO clear"]
    #[inline(always)]
    pub fn fifo0_clr_1(&self) -> FIFO0_CLR_1_R {
        FIFO0_CLR_1_R::new(((self.bits >> 8) & 0x01) != 0)
    }
    #[doc = "Bit 9 - FIFO clear"]
    #[inline(always)]
    pub fn fifo1_clr_1(&self) -> FIFO1_CLR_1_R {
        FIFO1_CLR_1_R::new(((self.bits >> 9) & 0x01) != 0)
    }
    #[doc = "Bit 10 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo0_lvl_1(&self) -> FIFO0_LVL_1_R {
        FIFO0_LVL_1_R::new(((self.bits >> 10) & 0x01) != 0)
    }
    #[doc = "Bit 11 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo1_lvl_1(&self) -> FIFO1_LVL_1_R {
        FIFO1_LVL_1_R::new(((self.bits >> 11) & 0x01) != 0)
    }
    #[doc = "Bit 12 - enable interrupt"]
    #[inline(always)]
    pub fn int_en_1(&self) -> INT_EN_1_R {
        INT_EN_1_R::new(((self.bits >> 12) & 0x01) != 0)
    }
    #[doc = "Bit 13 - Control Register Counter Enable"]
    #[inline(always)]
    pub fn cnt_start_1(&self) -> CNT_START_1_R {
        CNT_START_1_R::new(((self.bits >> 13) & 0x01) != 0)
    }
    #[doc = "Bit 16 - FIFO clear"]
    #[inline(always)]
    pub fn fifo0_clr_2(&self) -> FIFO0_CLR_2_R {
        FIFO0_CLR_2_R::new(((self.bits >> 16) & 0x01) != 0)
    }
    #[doc = "Bit 17 - FIFO clear"]
    #[inline(always)]
    pub fn fifo1_clr_2(&self) -> FIFO1_CLR_2_R {
        FIFO1_CLR_2_R::new(((self.bits >> 17) & 0x01) != 0)
    }
    #[doc = "Bit 18 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo0_lvl_2(&self) -> FIFO0_LVL_2_R {
        FIFO0_LVL_2_R::new(((self.bits >> 18) & 0x01) != 0)
    }
    #[doc = "Bit 19 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo1_lvl_2(&self) -> FIFO1_LVL_2_R {
        FIFO1_LVL_2_R::new(((self.bits >> 19) & 0x01) != 0)
    }
    #[doc = "Bit 20 - enable interrupt"]
    #[inline(always)]
    pub fn int_en_2(&self) -> INT_EN_2_R {
        INT_EN_2_R::new(((self.bits >> 20) & 0x01) != 0)
    }
    #[doc = "Bit 21 - Control Register Counter Enable"]
    #[inline(always)]
    pub fn cnt_start_2(&self) -> CNT_START_2_R {
        CNT_START_2_R::new(((self.bits >> 21) & 0x01) != 0)
    }
    #[doc = "Bit 24 - FIFO clear"]
    #[inline(always)]
    pub fn fifo0_clr_3(&self) -> FIFO0_CLR_3_R {
        FIFO0_CLR_3_R::new(((self.bits >> 24) & 0x01) != 0)
    }
    #[doc = "Bit 25 - FIFO clear"]
    #[inline(always)]
    pub fn fifo1_clr_3(&self) -> FIFO1_CLR_3_R {
        FIFO1_CLR_3_R::new(((self.bits >> 25) & 0x01) != 0)
    }
    #[doc = "Bit 26 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo0_lvl_3(&self) -> FIFO0_LVL_3_R {
        FIFO0_LVL_3_R::new(((self.bits >> 26) & 0x01) != 0)
    }
    #[doc = "Bit 27 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo1_lvl_3(&self) -> FIFO1_LVL_3_R {
        FIFO1_LVL_3_R::new(((self.bits >> 27) & 0x01) != 0)
    }
    #[doc = "Bit 28 - enable interrupt"]
    #[inline(always)]
    pub fn int_en_3(&self) -> INT_EN_3_R {
        INT_EN_3_R::new(((self.bits >> 28) & 0x01) != 0)
    }
    #[doc = "Bit 29 - Control Register Counter Enable"]
    #[inline(always)]
    pub fn cnt_start_3(&self) -> CNT_START_3_R {
        CNT_START_3_R::new(((self.bits >> 29) & 0x01) != 0)
    }
}
impl W {
    #[doc = "Bit 0 - FIFO clear"]
    #[inline(always)]
    pub fn fifo0_clr_0(&mut self) -> FIFO0_CLR_0_W {
        FIFO0_CLR_0_W { w: self }
    }
    #[doc = "Bit 1 - FIFO clear"]
    #[inline(always)]
    pub fn fifo1_clr_0(&mut self) -> FIFO1_CLR_0_W {
        FIFO1_CLR_0_W { w: self }
    }
    #[doc = "Bit 2 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo0_lvl_0(&mut self) -> FIFO0_LVL_0_W {
        FIFO0_LVL_0_W { w: self }
    }
    #[doc = "Bit 3 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo1_lvl_0(&mut self) -> FIFO1_LVL_0_W {
        FIFO1_LVL_0_W { w: self }
    }
    #[doc = "Bit 4 - enable interrupt"]
    #[inline(always)]
    pub fn int_en_0(&mut self) -> INT_EN_0_W {
        INT_EN_0_W { w: self }
    }
    #[doc = "Bit 5 - Control Register Counter Enable"]
    #[inline(always)]
    pub fn cnt_start_0(&mut self) -> CNT_START_0_W {
        CNT_START_0_W { w: self }
    }
    #[doc = "Bit 8 - FIFO clear"]
    #[inline(always)]
    pub fn fifo0_clr_1(&mut self) -> FIFO0_CLR_1_W {
        FIFO0_CLR_1_W { w: self }
    }
    #[doc = "Bit 9 - FIFO clear"]
    #[inline(always)]
    pub fn fifo1_clr_1(&mut self) -> FIFO1_CLR_1_W {
        FIFO1_CLR_1_W { w: self }
    }
    #[doc = "Bit 10 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo0_lvl_1(&mut self) -> FIFO0_LVL_1_W {
        FIFO0_LVL_1_W { w: self }
    }
    #[doc = "Bit 11 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo1_lvl_1(&mut self) -> FIFO1_LVL_1_W {
        FIFO1_LVL_1_W { w: self }
    }
    #[doc = "Bit 12 - enable interrupt"]
    #[inline(always)]
    pub fn int_en_1(&mut self) -> INT_EN_1_W {
        INT_EN_1_W { w: self }
    }
    #[doc = "Bit 13 - Control Register Counter Enable"]
    #[inline(always)]
    pub fn cnt_start_1(&mut self) -> CNT_START_1_W {
        CNT_START_1_W { w: self }
    }
    #[doc = "Bit 16 - FIFO clear"]
    #[inline(always)]
    pub fn fifo0_clr_2(&mut self) -> FIFO0_CLR_2_W {
        FIFO0_CLR_2_W { w: self }
    }
    #[doc = "Bit 17 - FIFO clear"]
    #[inline(always)]
    pub fn fifo1_clr_2(&mut self) -> FIFO1_CLR_2_W {
        FIFO1_CLR_2_W { w: self }
    }
    #[doc = "Bit 18 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo0_lvl_2(&mut self) -> FIFO0_LVL_2_W {
        FIFO0_LVL_2_W { w: self }
    }
    #[doc = "Bit 19 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo1_lvl_2(&mut self) -> FIFO1_LVL_2_W {
        FIFO1_LVL_2_W { w: self }
    }
    #[doc = "Bit 20 - enable interrupt"]
    #[inline(always)]
    pub fn int_en_2(&mut self) -> INT_EN_2_W {
        INT_EN_2_W { w: self }
    }
    #[doc = "Bit 21 - Control Register Counter Enable"]
    #[inline(always)]
    pub fn cnt_start_2(&mut self) -> CNT_START_2_W {
        CNT_START_2_W { w: self }
    }
    #[doc = "Bit 24 - FIFO clear"]
    #[inline(always)]
    pub fn fifo0_clr_3(&mut self) -> FIFO0_CLR_3_W {
        FIFO0_CLR_3_W { w: self }
    }
    #[doc = "Bit 25 - FIFO clear"]
    #[inline(always)]
    pub fn fifo1_clr_3(&mut self) -> FIFO1_CLR_3_W {
        FIFO1_CLR_3_W { w: self }
    }
    #[doc = "Bit 26 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo0_lvl_3(&mut self) -> FIFO0_LVL_3_W {
        FIFO0_LVL_3_W { w: self }
    }
    #[doc = "Bit 27 - FIFO fill status level control"]
    #[inline(always)]
    pub fn fifo1_lvl_3(&mut self) -> FIFO1_LVL_3_W {
        FIFO1_LVL_3_W { w: self }
    }
    #[doc = "Bit 28 - enable interrupt"]
    #[inline(always)]
    pub fn int_en_3(&mut self) -> INT_EN_3_W {
        INT_EN_3_W { w: self }
    }
    #[doc = "Bit 29 - Control Register Counter Enable"]
    #[inline(always)]
    pub fn cnt_start_3(&mut self) -> CNT_START_3_W {
        CNT_START_3_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Auxiliary Control\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [actl4](index.html) module"]
pub struct ACTL4_SPEC;
impl crate::RegisterSpec for ACTL4_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [actl4::R](R) reader structure"]
impl crate::Readable for ACTL4_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [actl4::W](W) writer structure"]
impl crate::Writable for ACTL4_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets ACTL4 to value 0"]
impl crate::Resettable for ACTL4_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
